//+------------------------------------------------------------------+
//|                                        TommiesonSupercharged.mq4 |
//|                        Copyright 2023, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
extern int RSI_period_1 = 14;
extern int RSI_period_2 = 14;
extern double buy_rsi_level_1 = 25.0;
extern double buy_rsi_level_2 = 20.0;
extern double buy_rsi_level_3 = 15.0;
extern double sell_rsi_level_1 = 75.0;
extern double sell_rsi_level_2 = 80.0;
extern double sell_rsi_level_3 = 85.0;

double lotsize_forex = 0.1; // default lotsize for forex
double lotsize_us30 = 0.5; // lotsize for US30
double lotsize_us500 = 2.0; // lotsize for US500
double lotsize_usoil = 0.25; // lotsize for USoil

void OnTick() {
    double ma20 = iMA(NULL, PERIOD_M1, 20, 0, MODE_SMA, PRICE_CLOSE, 0);
    double rsi1 = iRSI(NULL, PERIOD_M1, RSI_period_1, PRICE_CLOSE, 0);
    double rsi2 = iRSI(NULL, PERIOD_M5, RSI_period_2, PRICE_CLOSE, 0);

    int positions = PositionsTotal();
    string symbol = Symbol();
    double ask = SymbolInfoDouble(symbol, SYMBOL_ASK);
    double bid = SymbolInfoDouble(symbol, SYMBOL_BID);

    // Buy conditions
    if (rsi1 <= buy_rsi_level_1 && rsi2 <= buy_rsi_level_1 && positions < 1) {
        if (symbol == "EURUSD" || symbol == "GBPUSD" || symbol == "USDJPY" || symbol == "USDCHF" || symbol == "AUDUSD" || symbol == "NZDUSD" || symbol == "USDCAD") {
            double stopLoss = ask * 0.01; // 1% stop loss
            OrderSend(symbol, OP_BUY, lotsize_forex, ask, 0, stopLoss, 0, "Buy", 0, 0, Green);
        }
        else if (symbol == "US30") {
            double stopLoss = ask * 0.01; // 1% stop loss
            OrderSend(symbol, OP_BUY, lotsize_us30, ask, 0, stopLoss, 0, "Buy", 0, 0, Green);
        }
        else if (symbol == "US500") {
            double stopLoss = ask * 0.01; // 1% stop loss
            OrderSend(symbol, OP_BUY, lotsize_us500, ask, 0, stopLoss, 0, "Buy", 0, 0, Green);
        }
        else if (symbol == "USOIL") {
            double stopLoss = ask * 0.01; // 1% stop loss
            OrderSend(symbol, OP_BUY, lotsize_usoil, ask, 0, stopLoss, 0, "Buy", 0, 0, Green);
        }
    }
    if (rsi2 <= buy_rsi_level_2 && positions < 2) {
        if (symbol == "EURUSD" || symbol == "GBPUSD" || symbol == "USDJPY" || symbol == "USDCHF" || symbol == "AUDUSD" || symbol == "NZDUSD" || symbol == "USDCAD") {
            double stopLoss = ask * 0;
        }
        else if (symbol == "US500") {
            OrderSend(symbol, OP_BUY, lotsize_us500, ask, 0, 0, 0, "Buy", 0, 0, Green);
        }
        else if (symbol == "USOIL") {
            OrderSend(symbol, OP_BUY, lotsize_usoil, ask, 0, 0, 0, "Buy", 0, 0, Green);
                 }
        }
      if(rsi2 <= buy_rsi_level_3 && positions < 3)
        {
         if(symbol == "EURUSD" || symbol == "GBPUSD" || symbol == "USDJPY" || symbol == "USDCHF" || symbol == "AUDUSD" || symbol == "NZDUSD" || symbol == "USDCAD")
           {
            OrderSend(symbol, OP_BUY, lotsize_forex, ask, 0, 0, 0, "Buy", 0, 0, Green);
           }
         else
            if(symbol == "US30")
              {
               OrderSend(symbol, OP_BUY, lotsize_us30, ask, 0, 0, 0, "Buy", 0, 0, Green);
              }
            else
               if(symbol == "US500")
                 {
                  OrderSend(symbol, OP_BUY, lotsize_us500, ask, 0, 0, 0, "Buy", 0, 0, Green);
                 }
               else
                  if(symbol == "USOIL")
                    {
                     OrderSend(symbol, OP_BUY, lotsize_usoil, ask, 0, 0, 0, "Buy", 0, 0, Green);
                    }
        }

      // Sell conditions
      if(rsi1 >= sell_rsi_level_1 && rsi2 >= sell_rsi_level_1 && positions < 1)
        {
         if(symbol == "EURUSD" || symbol == "GBPUSD" || symbol == "USDJPY" || symbol == "USDCHF" || symbol == "AUDUSD" || symbol == "NZDUSD" || symbol == "USDCAD")
           {
            OrderSend(symbol, OP_SELL, lotsize_forex, bid, 0, 0, 0, "Sell", 0, 0, Red);
           }
         else
            if(symbol == "US30")
              {
               OrderSend(symbol, OP_SELL, lotsize_us30, bid, 0, 0, 0, "Sell", 0, 0, Red);
              }
            else
               if(symbol == "US500")
                 {
                  OrderSend(symbol, OP_SELL, lotsize_us500, bid, 0, 0, 0, "Sell", 0, 0, Red);
                 }
               else
                  if(symbol == "USOIL")
                    {
                     OrderSend(symbol, OP_SELL, lotsize_usoil, bid, 0, 0, 0, "Sell", 0, 0, Red);
                    }
        }
      if(rsi2 >= sell_rsi_level_2 && positions < 2)
        {
         if(symbol == "EURUSD" || symbol == "GBPUSD" || symbol == "USDJPY" || symbol == "USDCHF" || symbol == "AUDUSD" || symbol == "NZDUSD" || symbol == "USDCAD")
           {
            OrderSend(symbol, OP_SELL, lotsize_forex, bid, 0,
                      // Sell conditions
                      if(rsi1 >= sell_rsi_level_1 && rsi2 >= sell_rsi_level_1 && positions < 1)
           {
            if(symbol == "EURUSD" || symbol == "GBPUSD" || symbol == "USDJPY" || symbol == "USDCHF" || symbol == "AUDUSD" || symbol == "NZDUSD" || symbol == "USDCAD")
                 {
                  OrderSend(symbol, OP_SELL, lotsize_forex, bid, 0, Bid + stoploss*Point, 0, "Sell", 0, 0, Red);
                 }
               else
                  if(symbol == "US30")
                    {
                     OrderSend(symbol, OP_SELL, lotsize_us30, bid, 0, Bid + stoploss*Point, 0, "Sell", 0, 0, Red);
                    }
                  else
                     if(symbol == "US500")
                       {
                        OrderSend(symbol, OP_SELL, lotsize_us500, bid, 0, Bid + stoploss*Point, 0, "Sell", 0, 0, Red);
                       }
                     else
                        if(symbol == "USOIL")
                          {
                           OrderSend(symbol, OP_SELL, lotsize_usoil, bid, 0, Bid + stoploss*Point, 0, "Sell", 0, 0, Red);
                          }
              }
            if(rsi2 >= sell_rsi_level_3 && positions < 3)
           {
            if(symbol == "EURUSD" || symbol == "GBPUSD" || symbol == "USDJPY" || symbol == "USDCHF" || symbol == "AUDUSD" || symbol == "NZDUSD" || symbol == "USDCAD")
                 {
                  OrderSend(symbol, OP_SELL, lotsize_forex, bid, 0, Bid + stoploss*Point, 0, "Sell", 0, 0, Red);
                 }
               else
                  if(symbol == "US30")
                    {
                     OrderSend(symbol, OP_SELL, lotsize_us30, bid, 0, Bid + stoploss*Point, 0, "Sell", 0, 0, Red);
                    }
                  else
                     if(symbol == "US500")
                       {
                        OrderSend(symbol, OP_SELL, lotsize_us500, bid, 0, Bid + stoploss*Point, 0, "Sell", 0, 0, Red);
                       }
                     else
                        if(symbol == "USOIL")
                          {
                           OrderSend(symbol, OP_SELL, lotsize_usoil, bid, 0, Bid + stoploss*Point, 0, "Sell", 0, 0, Red);
                          }
              }
           }

         double GetLotSize(string symbol)
           {
            double balance = AccountBalance();
            double riskPercentage;
            if(symbol == "EURUSD" || symbol == "GBPUSD" || symbol == "AUDUSD" || symbol == "NZDUSD" || symbol == "USDJPY")
              {
               riskPercentage = 0.5;
              }
            else
               if(symbol == "US30")
                 {
                  riskPercentage = 2.5;
                 }
               else
                  if(symbol == "US500")
                    {
                     riskPercentage = 10.0;
                    }
                  else
                     if(symbol == "USOIL")
                       {
                        riskPercentage = 1.25;
                       }
                     else
                       {
                        Print("Invalid symbol");
                        return 0.1;
                       }
            double riskAmount = balance * (riskPercentage / 100
                                           // Sell conditions
                                           if(rsi1 >= sell_rsi_level_1 && rsi2 >= sell_rsi_level_1 && positions > -1)
           {
            for(int i = 0; i < positions; i++)
                 {
                  if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
                    {
                     if(OrderType() == OP_BUY && OrderSymbol() == symbol)
                       {
                        OrderClose(OrderTicket(), OrderLots(), Bid, 0, Red);
                       }
                    }
                 }
              }
            if(rsi2 >= sell_rsi_level_2 && positions > -2)
           {
            for(int i = 0; i < positions; i++)
                 {
                  if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
                    {
                     if(OrderType() == OP_BUY && OrderSymbol() == symbol)
                       {
                        OrderClose(OrderTicket(), OrderLots(), Bid, 0, Red);
                       }
                    }
                 }
              }
           }

         double GetLotSize(string symbol)
           {
            double balance = AccountBalance();
            double riskPercentage;
            if(symbol == "EURUSD" || symbol == "GBPUSD" || symbol == "AUDUSD" || symbol == "NZDUSD" || symbol == "USDJPY")
              {
               riskPercentage = 0.5;
              }
            else
               if(symbol == "US30")
                 {
                  riskPercentage = 2.5;
                 }
               else
                  if(symbol == "US500")
                    {
                     riskPercentage = 10.0;
                    }
                  else
                     if(symbol == "USOIL")
                       {
                        riskPercentage = 1.25;
                       }
                     else
                       {
                        Print("Invalid symbol");
                        return 0.1;
                       }
            double riskAmount = balance * (riskPercentage / 100.0);
            double stopLoss = 0.01 * MarketInfo(symbol, MODE_POINT); // 1% stop loss
            double pipValue = MarketInfo(symbol, MODE_TICKVALUE);
            double lotSize = NormalizeDouble(riskAmount / (stopLoss * pipValue), 2);
            return lotSize;
           }

         //+------------------------------------------------------------------+
